# Kluster
### a kubernetes operator (the hard way)

xmarlem.dev
v1alpha1


This is a naive implementation of an operator.

GOAL: trigger cluster creation in a cloud provider... it could wrap anything..


1. we first started creating the structs in pkg/api/GROUPAPI/VERSION/

There we need to create the types required... but this doesn't mean these types are automatically kubernetes objects.
In order to do that we need to register these object using schemes.

2. register

We created a special file called register.go
The goal is to register the Kluster and KlusterList types in kubernetes scheme. This is required in order to make kubernetes aware of these new types.

We referred to another project: code-generator... by looking at the examples...

3. code-generator

We need to generate additional things for our new types...
- informers
- listers
- clientset
- deep copy objects

code-generator is another project kubernetes maintainers maintain.

We need another file doc.go. Used to specify the global tags for our v1alpha1 api.
Tags are a way to control the behaviour of our code-generator.
There are two types of tags: local and global tags.

Global tags are written in doc.go
Local tags directly in types.go, before the struct declaration

Before:
```
.
├── README.md
├── go.mod
├── go.sum
├── main.go
└── pkg
    └── api
        └── xmarlem
            └── v1alpha1
                ├── doc.go
                ├── register.go
                └── types.go
```

After:
```
.
├── README.md
├── go.mod
├── go.sum
├── main.go
├── hack
├── pkg
│   ├── apis
│   │   └── xmarlem.dev
│   │       └── v1alpha1
│   │           ├── doc.go
│   │           ├── register.go
│   │           ├── types.go
│   │           └── zz_generated.deepcopy.go
│   └── generated
│       ├── clientset
│       ├── informers
│       └── listers
```


e.g.

genClient generates clientset




Command:
NOTE: it didn't work with the command used in the video... so, I had to google and found that sample-controller used a different approach.
They first are creating a tools.go file where they manage the loading of the code-generator library.
There is an update-codegen.sh script in hack folder that I had to adapt with data from this repo.

There is also a nice [guide here](https://play-with-go.dev/tools-as-dependencies_go119_en/) on how rather improve this by using go generate when using the tools.go.
....



Ricapitolando:
- ho creato types.go, con i tipi esterni che mi serve aggiungere/gestire
- register.go che mi serve per registrare questi tipi nello schema di kubernetes
  - per fare questo abbiamo creato uno SchemeBuilder, tramite apimachinery.runtime, e poi chiamiamo schemebuilder.Register che fa appunto la registrazione dei tipi.


We can now try to list this new type with the kluster clientset.
Now if I try to run the application I might get:
```2022/09/25 15:44:00 listing klusters the server could not find the requested resource (get klusters.xmarlem)```

this means we miss the CRD, so, kubernetes is not aware of these types.


4. generate CRD's

In order to generate CRDs (we could also write that manually), we need another command: controller-gen

Here how to install:

```bash
go install sigs.k8s.io/controller-tools/cmd/controller-gen@v0.7.0
```

```bash
controller-gen paths=gitlab.com/xmarlem1/k8s/kluster/pkg/apis/xmarlem/v1alpha1 crd:crdVersions=v1 output:crd:artifacts:config=manifests
```

NOTA: in doc.go we defined a tag: "// +groupName=xmarlem"
this is read by controller-gen! And CRDs will be generated by using that value as Group.

#### Note: CRDs under k8s.io ... have to be approved by kubernetes reviewers!

NB. if you try to apply with a tag under k8s.io... you will se an error message like this...

You need to add this annotation:

```yaml
  annotations:
    "api-approved.kubernetes.io": "unapproved, experimental-only; please get an approval from Kubernetes API reviewers if you're trying to develop a CRD in the *.k8s.io or *.kubernetes.io groups"
```

